#!/usr/local/bin/perl -w
use strict;
use CGI;
use Amazon::REST;
# use encoding 'utf-8'; for perl-5.8

my $query = CGI->new();
   $query->charset('utf-8'); # #1
my $keyword = $query->param('q');

if ($keyword) {
    my $amazon = Amazon::REST->new();
    my $data = $amazon->call(KeywordSearch => $keyword);
    print_form($query);
    print_data($query, $data);
} else {
    print_form($query);
}

sub print_form {
    my $query = shift;
    print $query->header,
	$query->start_html,
	$query->start_form(-method => 'GET'),
	$query->textfield(-name => 'q', -size => 12),
	$query->submit(-value => " Search "),
	$query->end_form;
}

sub print_data {
    my($query, $data) = @_;
    print $query->hr;

    if ($data->{ErrorMsg}) {
	print $data->{ErrorMsg};
	return;
    }

    my @details = ref($data->{Details})            #
	? @{$data->{Details}} : $data->{Details};  # #2
    for my $detail (@{$data->{Details}}) {
	my $link = $query->a(
	    { -href => $detail->{url} },
	    $query->img({
		-src => $detail->{ImageUrlMedium},
		-border => 0,
		-alt => $detail->{ProductName},
	    }),
	    $query->br,
	    $detail->{ProductName},
	);
	print $query->div(
	    { -style => "float:left;width:120px;margin:30px;" },
	    $link,
	);
    }
}
