#!/usr/local/bin/perl -w
use strict;
use CGI;
use LWP::Simple;
use URI;
use URI::QueryParam;
use XML::Simple;

my $token = "D16F26JZ1YEJIY";
my $assoc = "bulknews-22";

my $query = CGI->new();
   $query->charset('utf-8');
my $asin  = $query->param('asin');

if ($asin) {
    my $data = search_asin($asin); # #1
    print_form($query);
    print_data($query, $data);
} else {
    print_form($query);
}

sub search_asin {
    my $asin = shift;
    my $url = URI->new("http://xml.amazon.com/onca/xml3"); # #2
    $url->query_form_hash({                                #
	'dev-t' => $token,                                 #
	t       => $assoc,                                 #
	type    => 'lite',                                 #
	f       => 'xml',                                  #
	locale  => 'jp',                                   #
	page    => 1,                                      #
	AsinSearch => $asin,                               #
    });                                                    #
    my $xml = LWP::Simple::get($url); # #3
    my $data = XMLin($xml);           #
    return $data;
}

sub print_form {
    my $query = shift;
    print $query->header,
	$query->start_html,
	$query->start_form(-method => 'GET'),
	$query->textfield(-name => 'asin', -size => 12),
	$query->submit(-value => " Search "),
	$query->end_form;
}

sub print_data {
    my($query, $data) = @_;
    print $query->hr;

    if ($data->{ErrorMsg}) {    #
	print $data->{ErrorMsg};# #4
	return;                 #
    }

    my $detail = $data->{Details};
    print $query->a(                                    #
	{ -href => $detail->{url} },                     #
	$query->img({ -src => $detail->{ImageUrlMedium}, #
		      -border => 0,                      #
		      -alt => $detail->{ProductName},    # #5
		  }),                                    #
	$query->br,                                      #
	$detail->{ProductName},                          #
    );
}
